#include <iostream>
#include <algorithm>
#include <cstdlib>
#include <vector>
#include <unordered_map>
#include <unordered_set>

using namespace std;

char buf[(int) 2e5];
int n;
vector<pair<string, int>> a;
const int p1 = 239;
const int MOD1 = 1000000007;
const int p2 = 101;
const int MOD2 = 1000000009;

long long pack(long long x, long long y) {
    return (x << 32) + y;
}

bool memes() {
    vector<pair<int, int>> ans;
    unordered_map<long long, unordered_set<int>> prefs;
    for (int i = 0; i < 2 * n; i++) {
        long long hsh1 = 0, hsh2 = 0;
        bool ok = false;
        for (char j : a[i].first) {
            hsh1 = (hsh1 * p1 + j) % MOD1;
            hsh2 = (hsh2 * p2 + j) % MOD2;
        }
        long long hsh = pack(hsh1, hsh2);
        if (!prefs[hsh].empty()) {
            int ind = *prefs[hsh].begin();
            ans.push_back({i, ind});
            ok = true;

            long long hshx1 = 0, hshx2 = 0;
            for (int j = 0; j < a[ind].first.size(); j++) {
                hshx1 = (hshx1 * p1 + a[ind].first[j]) % MOD1;
                hshx2 = (hshx2 * p2 + a[ind].first[j]) % MOD2;
                prefs[pack(hshx1, hshx2)].erase(ind);
            }
        }
        if (ok) continue;

        long long h1 = 0, h2 = 0;
        for (int j = 0; j < a[i].first.size(); j++) {
            h1 = (h1 * p1 + a[i].first[j]) % MOD1;
            h2 = (h2 * p2 + a[i].first[j]) % MOD2;
            prefs[pack(h1, h2)].insert(i);
        }
    }

    if (ans.size() == n) {
        for (int i = 0; i < n; i++) {
            int i1 = ans[i].first, i2 = ans[i].second;
            if (a[i1].first.size() > a[i2].first.size()) {
                swap(i1, i2);
            }

            cout << a[i1].second + 1 << " " << a[i2].second + 1 << '\n';
        }
        return true;
    }
    return false;
}

void srt() {
    vector<pair<int, int>> lens(2 * n);
    for (int i = 0; i < 2 * n; i++) {
        lens[i] = {-a[i].first.size(), -i};
    }
    sort(lens.begin(), lens.end());
    vector<pair<string, int>> a1;
    a1.reserve(2 * n);
    for (int i = 0; i < 2 * n; i++) {
        a1.push_back(a[-lens[i].second]);
    }
    a.swap(a1);
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    srand(228239);
    scanf("%d", &n);
    a.resize(2 * n);
    for (int i = 0; i < 2 * n; i++) {
        scanf("%s", buf);
        a[i] = {string(buf), i};
    }

    srt();
    if (memes()) {
        return 0;
    } else {
        return 1;
    }
}
