#include "bits/stdc++.h"
#define puba push_back
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }

const int MAXN = 505;
char buf[MAXN];
int field[MAXN][MAXN];
int res[MAXN][MAXN];
int dx[4] = {1, 0, -1, 0};
int dy[4] = {0, 1, 0, -1};
int n, m;

int rec(int x, int y) {
    if (field[x][y] || !res[x][y]) {
        return 0;
    }
    
    vector<int> dirs;
    for (int i = 0; i < 4; ++i) {
        int nx = x + dx[i];
        int ny = y + dy[i];
        if (0 <= nx && nx < n && 0 <= ny && ny < m && res[nx][ny]) {
            dirs.puba(i);
        }
    }
    if (szof(dirs) == 2 && (dirs[1] - dirs[0] + 4) % 2 == 1) {
        int nx = x + dx[dirs[0]] + dx[dirs[1]];
        int ny = y + dy[dirs[0]] + dy[dirs[1]];
        if (res[nx][ny]) {
            res[x][y] = 0;
            rec(x + dx[dirs[0]], y + dy[dirs[0]]);
            rec(x + dx[dirs[1]], y + dy[dirs[1]]);
        }
    }
    return 0;
}

int main() {
    //freopen(TASK_NAME ".in", "r", stdin);
    //freopen(TASK_NAME ".out", "w", stdout);
    cerr << fixed << setprecision(15);
    cout << fixed << setprecision(15);
    
    scanf("%d%d", &n, &m);
    
    int minx = INF, maxx = -INF, miny = INF, maxy = -INF;
    for (int i = 0; i < n; ++i) {
        scanf("%s", buf);
        for (int j = 0; j < m; ++j) {
            if (buf[j] == '*') {
                field[i][j] = 1;
                minx = min(minx, i);
                maxx = max(maxx, i);
                miny = min(miny, j);
                maxy = max(maxy, j);
            }
        }
    }
    
    for (int i = minx; i <= maxx; ++i) {
        for (int j = miny; j <= maxy; ++j) {
            res[i][j] = 1;
        }
    }
    
    rec(minx, miny);
    rec(maxx, miny);
    rec(minx, maxy);
    rec(maxx, maxy);
    
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (res[i][j]) {
                cout << "*";
            } else {
                cout << ".";
            }
        }
        cout << "\n";
    }
    #ifdef LOCAL
        cerr << "time: " << clock() << endl;
    #endif
    return 0;
}