#include <stdio.h>
#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

const int N = 300005;
vector<int> st; //stack
bool isChild[N];
vector<pair<int, int> > ans;

struct Node {
	Node *nxt[26];
	vector<int> ends;
	Node() {
		for (int i = 0; i < 26; i++) {
			nxt[i] = NULL;
		}
	}
};

void dfs(Node *vert) {
	for (int i = 0; i < (int)(vert->ends.size()); i++) {
		st.push_back(vert->ends[i]);
	}

	for (int i = 0; i < 26; i++) {
		Node *child = vert->nxt[i];
		if (child != NULL) {
			dfs(child);
		}
	}

	for (int i = 0; i < (int)(vert->ends.size()); i++) {
		isChild[vert->ends[i]] = true;
	}
	while (st.size() > 1 && isChild[st.back()]) {
		int num1 = st.back();
		st.pop_back();
		int num2 = st.back();
		st.pop_back();
		ans.push_back(make_pair(num2, num1));
	}
	if (st.size() == 1 && isChild[st.back()]) {
		st.pop_back();
	}
	for (int i = 0; i < (int)(vert->ends.size()); i++) {
		isChild[vert->ends[i]] = false;
	}
}

int main() {
	int n;
	cin >> n;

	Node *root = new Node();
	for (int i = 1; i <= 2 * n; i++) {
		string str;
		cin >> str;
		Node *node = root;
		for (int j = 0; j < (int)str.size(); j++) {
			char letter = str[j] - 'a';
			if (node->nxt[letter] == NULL) {
				node->nxt[letter] = new Node();
			}
			node = node->nxt[letter];
			if (j == str.size() - 1) {
				node->ends.push_back(i);
			}
		}
	}

	dfs(root);

	for (int i = 0; i < (int)ans.size(); i++) {
		cout << ans[i].first << " " << ans[i].second << endl;
	}
	
	return 0;
}