#include "bits/stdc++.h"
#define puba push_back
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }

const int MAXN = 1e6 + 5, bp = 20;
int go[bp][MAXN];
int depth[MAXN];
vector<int> graph[MAXN];

int dfs0(int v, int p, int d) {
    depth[v] = d;
    for (int to : graph[v]) {
        if (to != p) {
            dfs0(to, v, d + 1);
        }
    }
    return 0;
}

int dfs1(int v, int p) {
    for (int to : graph[v]) {
        if (to != p) {
            dfs1(to, v);
            if (depth[go[0][to]] < depth[go[0][v]]) {
                go[0][v] = go[0][to];
            }
        }
    }
    return 0;
}

int dfs2(int v, int p) {
    for (int i = 1; i < bp; ++i) {
        go[i][v] = go[i - 1][go[i - 1][v]];
    }
    for (int to : graph[v]) {
        if (to != p) {
            dfs2(to, v);
        }
    }
    return 0;
}


int main() {
    //freopen(TASK_NAME ".in", "r", stdin);
    //freopen(TASK_NAME ".out", "w", stdout);
    cerr << fixed << setprecision(15);
    cout << fixed << setprecision(15);
    
    int n, m, q;
    scanf("%d", &n);

    for (int i = 0; i < n - 1; ++i) {
        int a, b;
        scanf("%d%d", &a, &b);
        --a; --b;
        graph[a].puba(b);
        graph[b].puba(a);
    }

    dfs0(0, 0, 0);

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < bp; ++j) {
            go[j][i] = i;
        }
    }

    scanf("%d", &m);
    
    for (int i = 0; i < m; ++i) {
        int a, b;
        scanf("%d%d", &a, &b);
        --a; --b;
        if (depth[b] < depth[go[0][a]]) {
            go[0][a] = b;
        }
    }

    dfs1(0, 0);

    dfs2(0, 0);
    
    scanf("%d", &q);

    for (int i = 0; i < q; ++i) {
        int v, k;
        scanf("%d%d", &v, &k);
        --v;
        for (int j = bp - 1; j >= 0; --j) {
            if (k & (1 << j)) {
                v = go[j][v];
            }
        }
        cout << v + 1 << "\n";
    }
    
    
    #ifdef LOCAL
        cerr << "time: " << clock() << endl;
    #endif
    return 0;
}                                        