#include <bits/stdc++.h>

using namespace std;

const int MOD = 1000 * 1000 * 1000 + 7;
const int MAXN = 3007;

int fact[MAXN];
int cnk[MAXN][MAXN];

int cnt[MAXN];
int dp[MAXN][MAXN];

void add(int &x, int y) {
    x += y;
    if (x >= MOD) x -= MOD;
}

int mul(int x, int y) {
    return (1LL * x * y) % MOD;
}

int main() {
    //freopen("socks.in", "r", stdin);
    //freopen("socks.out", "w", stdout);
	int n;
	scanf("%d", &n);
	fact[0] = 1;
	for (int i = 1; i <= n; i++) {
        fact[i] = mul(fact[i - 1], i);
		int x;
		scanf("%d", &x);
		cnt[x]++;
	}
    cnk[0][0] = 1;
    for (int i = 1; i < MAXN; i++) {
        cnk[i][0] = 1;
        for (int j = 1; j <= i; j++) {
            cnk[i][j] = cnk[i - 1][j];
            add(cnk[i][j], cnk[i - 1][j - 1]);
        }
    }

	dp[0][0] = 1;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j <= n; j++) {
			for (int k = 0; j + k <= n && k <= cnt[i + 1]; k++) {
				int go = dp[i][j];
                int tmp = cnk[cnt[i + 1]][k];
                go = mul(go, mul(tmp, tmp));
                go = mul(go, fact[k]);
                add(dp[i + 1][j + k], go);
			}
		}
	}
	int res = 0;
	for (int i = 0; i <= n; i++) {
		int go = mul(dp[n][i], fact[n - i]);
        if (i & 1) {
            add(res, MOD - go);
        } else {
            add(res, go);
        }
	}
	printf("%d\n", res);
}

